import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["disabled", "isFitted", "initialValue", "labelLeft", "labelRight", "size", "type", "onToggle", "value"];
import { forwardRef, useState } from 'react';
import PropTypes from 'prop-types';
import { SingleSwitchTypeRender } from './SwitchType/single.js';
import { ToggleSwitchTypeRender } from './SwitchType/toggle.js';
import { LABELS, SIZES, TYPES } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AtomSwitch = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$isFitted = _ref.isFitted,
    isFitted = _ref$isFitted === void 0 ? false : _ref$isFitted,
    _ref$initialValue = _ref.initialValue,
    initialValue = _ref$initialValue === void 0 ? false : _ref$initialValue,
    _ref$labelLeft = _ref.labelLeft,
    labelLeft = _ref$labelLeft === void 0 ? LABELS.LEFT : _ref$labelLeft,
    _ref$labelRight = _ref.labelRight,
    labelRight = _ref$labelRight === void 0 ? LABELS.RIGHT : _ref$labelRight,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? SIZES.DEFAULT : _ref$size,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? TYPES.TOGGLE : _ref$type,
    onToggleCallback = _ref.onToggle,
    value = _ref.value,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useState = useState(initialValue),
    isToggle = _useState[0],
    setIsToggle = _useState[1];
  var isChecked = value !== undefined ? value : isToggle;
  var onToggle = function onToggle(forcedValue) {
    return function (event) {
      var newIsToggle = forcedValue !== undefined ? forcedValue : !isToggle;
      if (value === undefined) {
        // if its uncontrolled component
        setIsToggle(newIsToggle);
      } else {
        newIsToggle = !value;
      }
      typeof onToggleCallback === 'function' && onToggleCallback(newIsToggle);
    };
  };
  var commonProps = _extends({
    disabled: disabled,
    isFitted: isFitted,
    initialValue: initialValue,
    labelLeft: labelLeft,
    labelRight: labelRight,
    size: size,
    type: type
  }, props, {
    isToggle: isToggle,
    isChecked: isChecked,
    onToggle: onToggle,
    value: value
  });
  return type === TYPES.SINGLE ? /*#__PURE__*/_jsx(SingleSwitchTypeRender, _extends({
    ref: ref
  }, commonProps)) : /*#__PURE__*/_jsx(ToggleSwitchTypeRender, _extends({
    ref: ref
  }, commonProps));
});
AtomSwitch.displayName = 'AtomSwitch';
export { SIZES as atomSwitchSizes };
export { TYPES as atomSwitchTypes };
export default AtomSwitch;